using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Military
{
    public class Military
    {

        public static void Main()
        {


            //Recruit
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Recruit M+",
                    NameToOrderByOverride = "Human2",
                    DescriptionOverride = "The fresh meat in the rankings",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/RecruitThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("HumanTextures/Recruit.png");
                        var flesh = ModAPI.LoadTexture("HumanFlesh.png");
                        var bone = ModAPI.LoadTexture("HumanSkeleton.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );

            //Soldier
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Soldier M+",
                    NameToOrderByOverride = "Human2",
                    DescriptionOverride = "Reliable and effective fighter",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/SoldierThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("HumanTextures/Soldier.png");
                        var flesh = ModAPI.LoadTexture("HumanFlesh.png");
                        var bone = ModAPI.LoadTexture("HumanSkeleton.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                    }
                }
            );

            //Captain
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Captain M+",
                    NameToOrderByOverride = "Human2",
                    DescriptionOverride = "Master gunman, Best of the best, Creme de la creme. You would not like to be put up against this guy.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/CaptainThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("HumanTextures/Captain.png");
                        var flesh = ModAPI.LoadTexture("HumanFlesh.png");
                        var bone = ModAPI.LoadTexture("HumanSkeleton.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                        //cosmetics
                        var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("hat");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0.02f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("HumanTextures/CaptainHat.png");
                        childSprite.sortingLayerName = "Top";
                    }
                }
            );

            //Mech Upper Leg
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), // Searches the ingame catalog and returns with the inputted string if possible.
                    NameOverride = "Mech Upper Leg M+", // Name.
                    DescriptionOverride = "Mech Upper Leg",// Description
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("Mech/UpperLeg.png"),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Mech/UpperLeg.png");//This line gets the component of the SpriteRenderer and overrides it by looking in the files. The 2f is the scale of the sprite.

                        //Collider

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        var _1 = Instance.AddComponent<BoxCollider2D>();
                        _1.offset = new Vector2(-0.1865617f, 0.5212331f);
                        _1.size = new Vector2(0.2840194f, 0.3575337f);

                        var _2 = Instance.AddComponent<BoxCollider2D>();
                        _2.offset = new Vector2(0.00571306f, 0.1293318f);
                        _2.size = new Vector2(0.4815324f, 0.8621442f);

                        var _3 = Instance.AddComponent<BoxCollider2D>();
                        _3.offset = new Vector2(0.1806029f, -0.4988509f);
                        _3.size = new Vector2(0.2877279f, 0.4022982f);

                    }
                }
            );


            //Mech Lower Leg
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), // Searches the ingame catalog and returns with the inputted string if possible.
                    NameOverride = "Mech Lower Leg M+", // Name.
                    DescriptionOverride = "Mech Lower Leg",// Description
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("Mech/LowerLeg.png"),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Mech/LowerLeg.png");//This line gets the component of the SpriteRenderer and overrides it by looking in the files. The 2f is the scale of the sprite.

                        //Collider

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        var _1 = Instance.AddComponent<BoxCollider2D>();
                        _1.offset = new Vector2(-0.1865617f, 0.5212331f);
                        _1.size = new Vector2(0.2840194f, 0.3575337f);

                        var _2 = Instance.AddComponent<BoxCollider2D>();
                        _2.offset = new Vector2(0.00571306f, 0.1293318f);
                        _2.size = new Vector2(0.4815324f, 0.8621442f);

                        var _3 = Instance.AddComponent<BoxCollider2D>();
                        _3.offset = new Vector2(0.1806029f, -0.4988509f);
                        _3.size = new Vector2(0.2877279f, 0.4022982f);

                    }
                }
            );

            //Mech Hull Small
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), // Searches the ingame catalog and returns with the inputted string if possible.
                    NameOverride = "Mech Hull Small M+", // Name.
                    DescriptionOverride = "Mech Hull Small",// Description
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("Mech/HullSmall.png"),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Mech/HullSmall.png");//This line gets the component of the SpriteRenderer and overrides it by looking in the files. The 2f is the scale of the sprite.

                    }
                }
            );


            //Mech Hull Large
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), // Searches the ingame catalog and returns with the inputted string if possible.
                    NameOverride = "Mech Hull Large M+", // Name.
                    DescriptionOverride = "Mech Hull Large",// Description
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("Mech/HullLarge.png"),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Mech/HullLarge.png");//This line gets the component of the SpriteRenderer and overrides it by looking in the files. The 2f is the scale of the sprite.

                        //Collider

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        var _1 = Instance.AddComponent<BoxCollider2D>();
                        _1.offset = new Vector2(0f, 0f);
                        _1.size = new Vector2(0.1714286f, 1.428571f);

                    }
                }
            );

            //Mech Hinge
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Ball"), // Searches the ingame catalog and returns with the inputted string if possible.
                    NameOverride = "Mech Hinge M+", // Name.
                    DescriptionOverride = "Mech Hinge",// Description
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("Mech/Hinge.png"),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Mech/Hinge.png")
                        };
                    }

                }
            );


            //Mech Back Arm
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), // Searches the ingame catalog and returns with the inputted string if possible.
                    NameOverride = "Mech Back Arm M+", // Name.
                    DescriptionOverride = "Mech Back Arm",// Description
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("Mech/BackArm.png"),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Mech/BackArm.png");//This line gets the component of the SpriteRenderer and overrides it by looking in the files. The 2f is the scale of the sprite.

                        //Collider

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        var _1 = Instance.AddComponent<BoxCollider2D>();
                        _1.offset = new Vector2(-0.5098345f, -0.07946038f);
                        _1.size = new Vector2(0.1231883f, 0.155365f);

                        var _2 = Instance.AddComponent<BoxCollider2D>();
                        _2.offset = new Vector2(-0.05709569f, 0f);
                        _2.size = new Vector2(0.7929635f, 0.3142857f);

                        var _3 = Instance.AddComponent<BoxCollider2D>();
                        _3.offset = new Vector2(0.4560171f, 0.05920672f);
                        _3.size = new Vector2(0.2308228f, 0.1958723f);
                    }
                }
            );

            //Mech Fore Arm
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), // Searches the ingame catalog and returns with the inputted string if possible.
                    NameOverride = "Mech Fore Arm M+", // Name.
                    DescriptionOverride = "Mech Fore Arm",// Description
                    CategoryOverride = ModAPI.FindCategory("Misc."),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("Mech/ForeArm.png"),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Mech/ForeArm.png");//This line gets the component of the SpriteRenderer and overrides it by looking in the files. The 2f is the scale of the sprite.

                        //Collider

                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        var _1 = Instance.AddComponent<BoxCollider2D>();
                        _1.offset = new Vector2(-0.4281687f, -0.04179293f);
                        _1.size = new Vector2(0.1436626f, 0.2021284f);

                        var _2 = Instance.AddComponent<BoxCollider2D>();
                        _2.offset = new Vector2(-0.05709569f, 0f);
                        _2.size = new Vector2(0.6031607f, 0.2857143f);

                        var _3 = Instance.AddComponent<BoxCollider2D>();
                        _3.offset = new Vector2(0.2732621f, -0.00174135f);
                        _3.size = new Vector2(0.06359844f, 0.1707835f);

                        var _4 = Instance.AddComponent<BoxCollider2D>();
                        _4.offset = new Vector2(0.4020609f, 0f);
                        _4.size = new Vector2(0.1958783f, 0.2857143f);
                    }
                }
            );

            //Military Android
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Military Android M+",
                    NameToOrderByOverride = "Android2",
                    DescriptionOverride = "Haha robot go brrrr",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/MilitaryAndroidThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("HumanTextures/MilitaryAndroid.png");
                        var flesh = ModAPI.LoadTexture("AndroidFlesh.png");
                        var bone = ModAPI.LoadTexture("AndroidSkeleton.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                    }
                }
            );



            //Pickup Truck
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Car"),
                    NameOverride = "Gunned Pickup Truck M+",
                    NameToOrderByOverride = "Car2",
                    DescriptionOverride = "Pick up the pace",
                    CategoryOverride = ModAPI.FindCategory("Vehicles"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/PickupThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Pickup/Pickup.png"),
                        };

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass *= 3f; //mass
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass *= 3f; //mass
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass *= 3f; //mass
                        var spriterenderer = Instance.GetComponent<SpriteRenderer>();
                        spriterenderer.sortingLayerName = "Top"; //Puts it on top of everything

                        //colliders vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }

                        var _1 = Instance.AddComponent<BoxCollider2D>();
                        _1.offset = new Vector2(0.8392266f, -0.008664846f);
                        _1.size = new Vector2(2.959622f, 0.9748006f);

                        var _2 = Instance.AddComponent<BoxCollider2D>();
                        _2.offset = new Vector2(-0.01010984f, 0.7780679f);
                        _2.size = new Vector2(1.259193f, 0.5867212f);

                        var _3 = Instance.AddComponent<BoxCollider2D>();
                        _3.offset = new Vector2(-1.648665f, -0.4188179f);
                        _3.size = new Vector2(2.012627f, 0.137337f);

                        var _4 = Instance.AddComponent<BoxCollider2D>();
                        _4.offset = new Vector2(-2.597859f, 0.03049576f);
                        _4.size = new Vector2(0.124846f, 0.756182f);

                        var _5 = Instance.AddComponent<BoxCollider2D>();
                        _5.offset = new Vector2(-1.543538f, -0.1816955f);
                        _5.size = new Vector2(0.8944178f, 0.339873f);

                        var _6 = Instance.AddComponent<BoxCollider2D>();
                        _6.offset = new Vector2(0.8332971f, 0.6673564f);
                        _6.size = new Vector2(0.4223287f, 0.3812708f);

                        //colliders ^^^^^^^^^^^^^^^^^^^^^^^^


                        // LMG on the back 
                        var lmg = ModAPI.FindSpawnable("Light Machine Gun"); //Gets the weapon, can be changed if u want
                        var lmgPrefab = lmg.Prefab; //gets the prefab of the spawnable object
                        var GunObject = GameObject.Instantiate(lmgPrefab, Instance.transform.position, Instance.transform.rotation); //Creates the gun

                        // sets the position on the truck
                        var body = Instance.transform.GetChild(0);
                        var childObject = GunObject;
                        childObject.transform.SetParent(body);
                        childObject.transform.localPosition = new Vector3(-0.05f, 1.85f); //position
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f); //rotation
                        childObject.transform.localScale = new Vector3(1f, 1f);//scale

                        //hinge for the gun
                        var hinge = Instance.AddComponent<HingeJoint2D>();
                        hinge.connectedBody = GunObject.GetComponent<Rigidbody2D>();
                        hinge.anchor = new Vector3(-1.6f, 1.32f); //anchor point

                        childObject.transform.SetParent(null); //un-parents the lmg to the truck because it breaks of it is still the child of the truck

                        var carbehaviour = Instance.GetComponent<CarBehaviour>();
                        carbehaviour.MotorSpeed = -1000f;

                        


                    }
                }
            );

                        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = "Body Armor M+", //new item name with a suffix to assure it is globally unique
                    NameToOrderByOverride = "Soldier 0 M+",
                    DescriptionOverride = "A protective layer designed to reduce or remove damage from gunshots and stabbing.", //new item description
                    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/BodyArmourThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BodyArmour/BodyArmourTop.png"); //get the SpriteRenderer and replace its sprite with a custom one

                        int PartCount = 3;

                        if (!Instance.GetComponent<ArmorBehaviourTest>())
                            Instance.AddComponent<ArmorBehaviourTest>();

                        ArmorBehaviourTest armor = Instance.GetComponent<ArmorBehaviourTest>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 2;
                        prop.sprite = "BodyArmour/BodyArmourTop.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "BodyArmour/BodyArmourMid.png";
                        armProp[0].armorTier = 2;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "BodyArmour/BodyArmourBot.png";
                        armProp[1].armorTier = 2;
                        armProp[1].armorPiece = "LowerBody";

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviourTest[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            //Gorsian
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Gorsian M+",
                    NameToOrderByOverride = "Human2",
                    DescriptionOverride = "Although they are from the same planet and derrive from the same species, the gorsian and gorse very much hate eachother",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/GorsianThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("AlienTextures/Gorsian.png");
                        var flesh = ModAPI.LoadTexture("AlienTextures/GorsianFlesh.png");
                        var bone = ModAPI.LoadTexture("AlienTextures/GorsianSkeleton.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);

                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), //item to derive from
                    NameOverride = "Gorsian Armor M+", //new item name with a suffix to assure it is globally unique
                    NameToOrderByOverride = "Gorsian 2",
                    DescriptionOverride = "The standard issue armor from the gorsian military", //new item description
                    CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/GorsianArmourThumb.png"), //new item thumbnail (relative path)
                    AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AlienTextures/AlienHelm.png"); //get the SpriteRenderer and replace its sprite with a custom one

                        int PartCount = 8;

                        if (!Instance.GetComponent<ArmorBehaviourTest>())
                            Instance.AddComponent<ArmorBehaviourTest>();

                        ArmorBehaviourTest armor = Instance.GetComponent<ArmorBehaviourTest>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 0;
                        prop.sprite = "AlienTextures/AlienTop.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "AlienTextures/AlienMid.png";
                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].armorTier = 2;

                        armProp[1].sprite = "AlienTextures/AlienBot.png";
                        armProp[1].armorPiece = "LowerBody";
                        armProp[1].armorTier = 2;

                        armProp[2].sprite = "AlienTextures/AlienUpLeg.png";
                        armProp[2].armorPiece = "UpperLeg";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 2;

                        armProp[3].sprite = "AlienTextures/AlienLowLeg.png";
                        armProp[3].armorPiece = "LowerLeg";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 2;

                        armProp[4].sprite = "AlienTextures/AlienFoot.png";
                        armProp[4].armorPiece = "Foot";
                        armProp[4].clone = true;

                        armProp[5].sprite = "AlienTextures/AlienArm.png";
                        armProp[5].armorPiece = "UpperArm";
                        armProp[5].clone = true;
                        armProp[5].armorTier = 2;


                        armProp[6].sprite = "AlienTextures/AlienHelm.png";
                        armProp[6].armorPiece = "Head";
                        armProp[6].armorTier = 2;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviourTest[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );


        }

    }
}